diff --git a/lib/hive/agent.rb b/lib/hive/agent.rb
index 1d4ba20b..e7dd38be 100644
--- a/lib/hive/agent.rb
+++ b/lib/hive/agent.rb
@@ -13,6 +13,10 @@ require "hive/permission_scope"
 module Hive
   class Agent
     FINAL_MESSAGE_TAIL_BYTES = 64 * 1024
+    # Bounded stream tail retained for diagnostic classification (e.g.
+    # FailureSignature on implementer_failed). Sized so a 401/auth line
+    # near the end of a noisy run still reaches the marker writer.
+    OUTPUT_TAIL_BYTES = 8 * 1024
 
     # Screenote's base URL reaches the agent as prompt/MCP-config context,
     # not as a child-environment input. nil unsets the var for the child so
@@ -131,6 +135,7 @@ module Hive
       limit_text = nil
       last_usage = nil
       plain_tail = +""
+      output_tail = +""
       stdin_file = prompt_stdin_file
       File.open(log_file, "a") do |log|
         log.puts "[hive] #{Time.now.utc.iso8601} spawn cwd=#{@cwd} cmd=#{cmd.inspect}"
@@ -157,6 +162,8 @@ module Hive
             log.write("[stream] #{Time.now.utc.iso8601} #{line}")
             log.write("\n") unless line.end_with?("\n")
             log.flush
+            output_tail << line
+            output_tail = output_tail.byteslice(-OUTPUT_TAIL_BYTES, OUTPUT_TAIL_BYTES) || output_tail
             json = parse_json_line(line)
             if json && (message = Hive::Agent::MessageExtractor.extract(json))
               final_message = message
@@ -244,6 +251,10 @@ module Hive
         final_message: message,
         final_message_source: message_source,
         limit_text: limit_text,
+        # Bounded combined stdout/stderr tail for FailureSignature and
+        # other write-time classifiers. Survives exit_code-only paths
+        # where error_message is just "exit_code=N".
+        output_tail: output_tail.to_s,
         usage: last_usage,
         model: last_usage && last_usage[:model],
         status: nil
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index c686876b..a8900ff5 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -355,7 +355,15 @@ module Hive
         "child_kill_grace_sec" => 30,
         "child_verb_timeouts" => { "digest" => 3600, "answer-digest" => 3600 },
         "log_max_bytes" => 10_485_760,
-        "log_max_files" => 5
+        "log_max_files" => 5,
+        # Global kill-switch for probe-gated terminal ERROR auto-retry
+        # (implementer_failed codex_auth + claude_launch_failed). When false
+        # the new paths are inert; pre-existing healer recoveries
+        # (limits_reached, timeout, agent-loss, ensure_clean_on_exit_failed)
+        # keep their own budgets and are NOT gated by this flag.
+        "auto_retry" => {
+          "enabled" => true
+        }
       },
       # Update flow (plan 2026-05-27-002). The daemon checks the latest
       # release on a throttled cadence and, on the install.sh channel,
@@ -2225,6 +2233,21 @@ module Hive
               "(true / false); got #{autostart.inspect} (#{autostart.class})"
       end
 
+      auto_retry = daemon["auto_retry"]
+      unless auto_retry.nil?
+        unless auto_retry.is_a?(Hash)
+          raise ConfigError,
+                "daemon.auto_retry in #{describe_source(source_path)} must be a Hash; " \
+                "got #{auto_retry.inspect} (#{auto_retry.class})"
+        end
+        enabled = auto_retry["enabled"]
+        unless enabled.nil? || enabled == true || enabled == false
+          raise ConfigError,
+                "daemon.auto_retry.enabled in #{describe_source(source_path)} must be a boolean " \
+                "(true / false); got #{enabled.inspect} (#{enabled.class})"
+        end
+      end
+
       DAEMON_NUMERIC_BOUNDS.each do |key, min|
         value = daemon[key]
         next if value.nil?
diff --git a/lib/hive/daemon/dispatcher.rb b/lib/hive/daemon/dispatcher.rb
index 1f272c69..81f6838b 100644
--- a/lib/hive/daemon/dispatcher.rb
+++ b/lib/hive/daemon/dispatcher.rb
@@ -12,6 +12,7 @@ require "hive/daemon/concurrency_controller"
 require "hive/daemon/child_supervisor"
 require "hive/daemon/status_consumer"
 require "hive/daemon/stale_agent_healer"
+require "hive/daemon/health_probes"
 require "hive/daemon/display_name_backfiller"
 require "hive/daemon/task_id_backfiller"
 require "hive/daemon/dispatch_request_queue"
@@ -100,10 +101,13 @@ module Hive
           "agent_marker_grace_sec",
           Hive::TaskAction::DEFAULT_AGENT_MARKER_GRACE_SEC
         )
+        @health_probes = HealthProbes.new
         @stale_agent_healer = StaleAgentHealer.new(
           controller: @controller,
           logger: @logger,
-          grace_sec: agent_marker_grace_sec
+          grace_sec: agent_marker_grace_sec,
+          auto_retry_enabled: auto_retry_enabled_from_cfg(@daemon_cfg),
+          health_probes: @health_probes
         )
         # Additive self-heal for tasks whose one-shot name generation at
         # `hive new` never landed (agent/codex outage). Re-spawns
@@ -1823,13 +1827,16 @@ module Hive
         # one tick. Without this rebuild the healer keeps the grace it
         # captured at boot and only a full daemon restart applies new
         # values.
+        @health_probes = HealthProbes.new
         @stale_agent_healer = StaleAgentHealer.new(
           controller: @controller,
           logger: @logger,
           grace_sec: @daemon_cfg.fetch(
             "agent_marker_grace_sec",
             Hive::TaskAction::DEFAULT_AGENT_MARKER_GRACE_SEC
-          )
+          ),
+          auto_retry_enabled: auto_retry_enabled_from_cfg(@daemon_cfg),
+          health_probes: @health_probes
         )
         # Rebuild alongside the healer on SIGHUP reload so a future
         # operator-tunable knob (e.g. max_per_tick) would take effect
@@ -1851,6 +1858,18 @@ module Hive
                               keeping_previous: true)
       end
 
+      # Probe-gated auto-retry kill-switch. Defaults true when the key is
+      # absent (deep-merge always supplies DEFAULTS, but be defensive for
+      # partial test configs). Only gates the new codex_auth /
+      # claude_launch_failed paths — never the pre-existing healer recoveries.
+      def auto_retry_enabled_from_cfg(daemon_cfg)
+        block = daemon_cfg.is_a?(Hash) ? daemon_cfg["auto_retry"] : nil
+        return true unless block.is_a?(Hash)
+        return true unless block.key?("enabled")
+
+        block["enabled"] == true
+      end
+
       def install_signal_handlers!
         Signal.trap("TERM") { @shutdown = true }
         Signal.trap("INT")  { @shutdown = true }
diff --git a/lib/hive/daemon/health_probes.rb b/lib/hive/daemon/health_probes.rb
new file mode 100644
index 00000000..e07479f5
--- /dev/null
+++ b/lib/hive/daemon/health_probes.rb
@@ -0,0 +1,530 @@
+# frozen_string_literal: true
+
+require "digest"
+require "json"
+require "open3"
+
+require "hive"
+require "hive/agent_profiles"
+require "hive/claude_launcher"
+require "hive/invoked_binary"
+require "hive/paths"
+
+module Hive
+  module Daemon
+    # Probe suites the StaleAgentHealer consults before auto-retrying a
+    # probe-gated terminal ERROR (implementer_failed codex_auth,
+    # claude_launch_failed). External CLIs are shelled out with hard
+    # timeouts; Hive-owned facts are checked in-process. Results are
+    # memoized per (tick, suite) and failed suites are rate-limited until
+    # the health-signal fingerprint changes or the fallback interval elapses.
+    class HealthProbes
+      DOCTOR_TIMEOUT_SEC = 30
+      CODEX_LOGIN_TIMEOUT_SEC = 10
+      CODEX_EXEC_TIMEOUT_SEC = 30
+      CLI_VERSION_TIMEOUT_SEC = 10
+      FALLBACK_REPROBE_INTERVAL_SEC = 15 * 60
+      OUTPUT_EXCERPT_BYTES = 512
+
+      ProbeResult = Struct.new(
+        :healthy,
+        :fingerprint,
+        :probes,
+        :excerpts,
+        :rationale,
+        keyword_init: true
+      )
+
+      def initialize(hive_bin: nil, codex_bin: nil, claude_bin: nil, env: ENV,
+                     now_provider: -> { Time.now },
+                     doctor_timeout_sec: DOCTOR_TIMEOUT_SEC,
+                     codex_login_timeout_sec: CODEX_LOGIN_TIMEOUT_SEC,
+                     codex_exec_timeout_sec: CODEX_EXEC_TIMEOUT_SEC,
+                     cli_version_timeout_sec: CLI_VERSION_TIMEOUT_SEC)
+        @hive_bin = hive_bin
+        @codex_bin = codex_bin
+        @claude_bin = claude_bin
+        @env = env
+        @now_provider = now_provider
+        @doctor_timeout_sec = doctor_timeout_sec
+        @codex_login_timeout_sec = codex_login_timeout_sec
+        @codex_exec_timeout_sec = codex_exec_timeout_sec
+        @cli_version_timeout_sec = cli_version_timeout_sec
+        @tick_cache = {}
+        # suite_key => { fingerprint:, at:, result: }
+        @last_eval = {}
+      end
+
+      # Evaluate the probe suite for +reason+. +now+ is the dispatcher's
+      # frozen tick clock so N parked markers with the same reason cost one
+      # probe run per tick.
+      def evaluate(reason:, now: @now_provider.call)
+        suite = suite_for(reason)
+        return unhealthy_result(fingerprint(now: now), rationale: "unknown_reason") if suite.nil?
+
+        cache_key = [ now.to_f, suite ]
+        return @tick_cache[cache_key] if @tick_cache.key?(cache_key)
+
+        fp = fingerprint(now: now)
+        if (cached = rate_limited_result(suite, fp, now))
+          @tick_cache[cache_key] = cached
+          return cached
+        end
+
+        result = run_suite(suite, fingerprint: fp)
+        @last_eval[suite] = { fingerprint: fp, at: now, result: result }
+        @tick_cache[cache_key] = result
+        result
+      end
+
+      # Cheap health-signal digest. Changes when binaries, wrappers,
+      # auth state, or global config mtimes move — used both to decide
+      # re-probing and as the "something fixed" gate between retries.
+      def fingerprint(now: @now_provider.call) # rubocop:disable Lint/UnusedMethodArgument
+        parts = [
+          "hive_bin=#{resolved_hive_bin}",
+          "hive_bin_mtime=#{file_mtime(resolved_hive_bin)}",
+          "hive_version=#{Hive::VERSION}",
+          "cli_version=#{cli_reported_version}",
+          "wrapper=#{wrapper_path}",
+          "wrapper_mtime=#{file_mtime(wrapper_path)}",
+          "codex_bin=#{resolved_codex_bin}",
+          "codex_bin_mtime=#{file_mtime(resolved_codex_bin)}",
+          "codex_auth_mtime=#{file_mtime(codex_auth_path)}",
+          "codex_auth_present=#{File.file?(codex_auth_path)}",
+          "global_config_mtime=#{file_mtime(global_config_path)}",
+          "skill_inventory=#{skill_inventory_hash}"
+        ]
+        Digest::SHA256.hexdigest(parts.join("|"))
+      end
+
+      # Drop per-tick memoization (callers that inject a new now each
+      # tick do not need this; exposed for tests).
+      def clear_tick_cache!
+        @tick_cache.clear
+      end
+
+      private
+
+      def suite_for(reason)
+        case reason.to_s
+        when "implementer_failed" then :codex_auth
+        when "claude_launch_failed" then :claude_launcher
+        end
+      end
+
+      def rate_limited_result(suite, fp, now)
+        prev = @last_eval[suite]
+        return nil unless prev
+        return nil if prev[:fingerprint] != fp
+        return nil if prev[:result].healthy
+        return nil if (now - prev[:at]) >= FALLBACK_REPROBE_INTERVAL_SEC
+
+        prev[:result]
+      end
+
+      def run_suite(suite, fingerprint:)
+        case suite
+        when :codex_auth
+          run_codex_auth_suite(fingerprint: fingerprint)
+        when :claude_launcher
+          run_claude_launcher_suite(fingerprint: fingerprint)
+        else
+          unhealthy_result(fingerprint, rationale: "unknown_suite")
+        end
+      end
+
+      def run_codex_auth_suite(fingerprint:)
+        probes = {}
+        excerpts = {}
+
+        doctor = doctor_green?
+        probes["doctor"] = doctor[:ok]
+        excerpts["doctor"] = doctor[:excerpt]
+
+        login = codex_login_status
+        probes["codex_login"] = login[:ok]
+        excerpts["codex_login"] = login[:excerpt]
+
+        smoke = codex_exec_smoke
+        probes["codex_smoke"] = smoke[:ok]
+        excerpts["codex_smoke"] = smoke[:excerpt]
+
+        healthy = probes.values.all?
+        rationale = if healthy
+                      "healthy"
+        else
+                      failed = probes.select { |_, v| !v }.keys.first
+                      "probe_failed:#{failed}"
+        end
+        ProbeResult.new(
+          healthy: healthy,
+          fingerprint: fingerprint,
+          probes: probes,
+          excerpts: excerpts,
+          rationale: rationale
+        )
+      end
+
+      def run_claude_launcher_suite(fingerprint:)
+        probes = {}
+        excerpts = {}
+
+        wrapper = wrapper_present?
+        probes["wrapper"] = wrapper[:ok]
+        excerpts["wrapper"] = wrapper[:excerpt]
+
+        ready = ready_detector_ok?
+        probes["ready_detector"] = ready[:ok]
+        excerpts["ready_detector"] = ready[:excerpt]
+
+        versions = binary_version_match?
+        probes["binary_version"] = versions[:ok]
+        excerpts["binary_version"] = versions[:excerpt]
+
+        doctor = doctor_green?
+        probes["doctor"] = doctor[:ok]
+        excerpts["doctor"] = doctor[:excerpt]
+
+        healthy = probes.values.all?
+        rationale = if healthy
+                      "healthy"
+        else
+          failed = probes.select { |_, v| !v }.keys.first
+          "probe_failed:#{failed}"
+        end
+        ProbeResult.new(
+          healthy: healthy,
+          fingerprint: fingerprint,
+          probes: probes,
+          excerpts: excerpts,
+          rationale: rationale
+        )
+      end
+
+      def doctor_green?
+        bin = resolved_hive_bin
+        return { ok: false, excerpt: "hive binary unresolved" } if bin.nil? || bin.empty?
+
+        out, err, status = capture_with_timeout(
+          [ bin, "doctor", "--json" ],
+          timeout_sec: @doctor_timeout_sec
+        )
+        combined = [ out, err ].join
+        excerpt = bound_excerpt(combined)
+        return { ok: false, excerpt: excerpt.empty? ? "doctor timed out or spawn failed" : excerpt } unless status
+
+        unless status.exitstatus&.zero?
+          return { ok: false, excerpt: excerpt.empty? ? "doctor exit=#{status.exitstatus}" : excerpt }
+        end
+
+        begin
+          payload = JSON.parse(out.to_s)
+        rescue JSON::ParserError
+          return { ok: false, excerpt: bound_excerpt("unparseable doctor json: #{out}") }
+        end
+
+        unless payload.is_a?(Hash) && payload["schema"].to_s == "hive-doctor.v1"
+          return { ok: false, excerpt: bound_excerpt("unexpected doctor schema: #{payload.inspect}") }
+        end
+
+        summary = payload["summary"]
+        if summary.is_a?(Hash)
+          missing = summary["missing"].to_i
+          too_old = summary["version_too_old"].to_i
+          if missing.positive? || too_old.positive?
+            return {
+              ok: false,
+              excerpt: bound_excerpt("doctor failures missing=#{missing} version_too_old=#{too_old}")
+            }
+          end
+        end
+
+        { ok: true, excerpt: excerpt }
+      end
+
+      def codex_login_status
+        bin = resolved_codex_bin
+        return { ok: false, excerpt: "codex binary unresolved" } if bin.nil? || bin.empty?
+
+        out, err, status = capture_with_timeout(
+          [ bin, "login", "status" ],
+          timeout_sec: @codex_login_timeout_sec
+        )
+        combined = [ out, err ].join
+        excerpt = bound_excerpt(combined)
+        return { ok: false, excerpt: excerpt.empty? ? "codex login status failed" : excerpt } unless status&.exitstatus&.zero?
+
+        text = combined.downcase
+        logged_in = text.match?(/logged in|authenticated|signed in/) &&
+                    !text.match?(/not logged in|not authenticated|logged out/)
+        # Some codex builds print a short "Logged in as …" only; others print
+        # nothing useful on success. Exit 0 alone is accepted when the text
+        # does not clearly say logged out.
+        logged_in ||= status.exitstatus.zero? && !text.match?(/not logged in|not authenticated|logged out|login required/)
+        { ok: logged_in, excerpt: excerpt }
+      end
+
+      def codex_exec_smoke
+        bin = resolved_codex_bin
+        return { ok: false, excerpt: "codex binary unresolved" } if bin.nil? || bin.empty?
+
+        # Minimal non-destructive smoke: empty prompt / version-like noop.
+        # The fake fixture and real codex both treat a short exec prompt as
+        # a full turn; keep the prompt tiny.
+        out, err, status = capture_with_timeout(
+          [ bin, "exec", "--json", "reply with ok" ],
+          timeout_sec: @codex_exec_timeout_sec
+        )
+        combined = [ out, err ].join
+        excerpt = bound_excerpt(combined)
+        return { ok: false, excerpt: excerpt.empty? ? "codex exec smoke failed" : excerpt } unless status&.exitstatus&.zero?
+
+        # Auth failures often exit non-zero, but also guard the body text.
+        text = combined.downcase
+        if text.match?(/401|unauthorized|not authenticated|missing bearer|basic auth|login required/)
+          return { ok: false, excerpt: excerpt }
+        end
+
+        { ok: true, excerpt: excerpt }
+      end
+
+      def wrapper_present?
+        path = wrapper_path
+        if path && File.file?(path)
+          { ok: true, excerpt: "wrapper=#{path}" }
+        else
+          { ok: false, excerpt: "wrapper missing: #{path.inspect}" }
+        end
+      end
+
+      # Self-check the ready-detector regexes against bundled fixtures that
+      # mirror the Claude Code idle prompt shapes the launcher accepts.
+      def ready_detector_ok?
+        fixtures = ready_detector_fixtures
+        fixtures.each do |label, text|
+          unless pane_looks_ready?(text)
+            return { ok: false, excerpt: "ready-detector failed fixture=#{label}" }
+          end
+        end
+        { ok: true, excerpt: "ready-detector ok (#{fixtures.size} fixtures)" }
+      rescue StandardError => e
+        { ok: false, excerpt: "ready-detector error: #{e.class}: #{e.message}" }
+      end
+
+      def ready_detector_fixtures
+        {
+          "caret_start" => [
+            "Claude Code v2.1.118",
+            "",
+            "❯ "
+          ].join("\n"),
+          "caret_end" => [
+            "Claude Code",
+            "project main",
+            " project main  ❯",
+            "─" * 20,
+            "for agents"
+          ].join("\n")
+        }
+      end
+
+      # Minimal in-process replica of ClaudeLauncher readiness checks so a
+      # broken CLAUDE_READY_* constant does not silently pass the probe.
+      def pane_looks_ready?(pane)
+        return false if pane.nil? || pane.empty?
+        return false unless pane.include?(Hive::ClaudeLauncher::CLAUDE_READY_BANNER_MARKER) ||
+                            pane.include?(Hive::ClaudeLauncher::CLAUDE_READY_FOOTER_MARKER)
+
+        lines = pane.lines.map(&:chomp)
+        lines.any? { |line| line.match?(Hive::ClaudeLauncher::CLAUDE_READY_PROMPT_LINE) }
+      end
+
+      def binary_version_match?
+        hive_ver = Hive::VERSION.to_s
+        cli_ver = cli_reported_version.to_s
+        if cli_ver.empty?
+          return { ok: false, excerpt: "cli version unreadable" }
+        end
+        # Compare the leading semver token so build suffixes don't false-negative.
+        hive_token = hive_ver[/\d+\.\d+\.\d+/] || hive_ver
+        cli_token = cli_ver[/\d+\.\d+\.\d+/] || cli_ver
+        if hive_token == cli_token
+          { ok: true, excerpt: "hive=#{hive_ver} cli=#{cli_ver}" }
+        else
+          { ok: false, excerpt: "version mismatch hive=#{hive_ver} cli=#{cli_ver}" }
+        end
+      end
+
+      def cli_reported_version
+        bin = resolved_hive_bin
+        return "" if bin.nil? || bin.empty?
+
+        out, _err, status = capture_with_timeout(
+          [ bin, "--version" ],
+          timeout_sec: @cli_version_timeout_sec
+        )
+        return "" unless status&.exitstatus&.zero?
+
+        out.to_s.strip
+      end
+
+      def capture_with_timeout(argv, timeout_sec:)
+        env_hash = @env.respond_to?(:to_hash) ? @env.to_hash : @env
+        r_out, w_out = IO.pipe
+        r_err, w_err = IO.pipe
+        pid = Process.spawn(env_hash, *argv, out: w_out, err: w_err, pgroup: true)
+        w_out.close
+        w_err.close
+
+        stdout = +""
+        stderr = +""
+        out_t = Thread.new { stdout << r_out.read.to_s }
+        err_t = Thread.new { stderr << r_err.read.to_s }
+
+        deadline = Time.now + timeout_sec
+        status = nil
+        timed_out = false
+        loop do
+          captured = Process.wait2(pid, Process::WNOHANG)
+          if captured
+            status = captured.last
+            break
+          end
+          if Time.now >= deadline
+            timed_out = true
+            kill_process_group(pid)
+            status = begin
+              Process.wait2(pid).last
+            rescue StandardError
+              nil
+            end
+            break
+          end
+          sleep 0.05
+        end
+
+        out_t.join(2)
+        err_t.join(2)
+        out_t.kill if out_t.alive?
+        err_t.kill if err_t.alive?
+        return [ stdout, stderr, nil ] if timed_out
+
+        [ stdout, stderr, status ]
+      rescue StandardError => e
+        kill_process_group(pid) if defined?(pid) && pid
+        [ stdout.to_s, "#{stderr}\n#{e.class}: #{e.message}", nil ]
+      ensure
+        r_out&.close unless r_out.nil? || r_out.closed?
+        r_err&.close unless r_err.nil? || r_err.closed?
+        w_out&.close unless w_out.nil? || w_out.closed?
+        w_err&.close unless w_err.nil? || w_err.closed?
+      end
+
+      def kill_process_group(pid)
+        return unless pid
+
+        Process.kill("TERM", -pid)
+        deadline = Time.now + 1
+        while Time.now < deadline
+          begin
+            Process.kill(0, pid)
+          rescue Errno::ESRCH
+            return
+          end
+          sleep 0.05
+        end
+        Process.kill("KILL", -pid)
+      rescue Errno::ESRCH, Errno::EPERM, Errno::EINVAL
+        begin
+          Process.kill("KILL", pid)
+        rescue Errno::ESRCH, Errno::EPERM
+          nil
+        end
+      end
+
+      def bound_excerpt(text)
+        s = text.to_s
+        return s if s.bytesize <= OUTPUT_EXCERPT_BYTES
+
+        s.byteslice(-OUTPUT_EXCERPT_BYTES, OUTPUT_EXCERPT_BYTES) || s
+      end
+
+      def unhealthy_result(fingerprint, rationale:)
+        ProbeResult.new(
+          healthy: false,
+          fingerprint: fingerprint,
+          probes: {},
+          excerpts: {},
+          rationale: rationale
+        )
+      end
+
+      def resolved_hive_bin
+        return @hive_bin if @hive_bin
+
+        @resolved_hive_bin ||= begin
+          Hive::InvokedBinary.path ||
+            Hive::InvokedBinary.which("hive", env: @env) ||
+            "hive"
+        end
+      end
+
+      def resolved_codex_bin
+        return @codex_bin if @codex_bin
+
+        @resolved_codex_bin ||= begin
+          override = @env["HIVE_CODEX_BIN"].to_s
+          if !override.empty? && File.executable?(override)
+            override
+          else
+            profile = Hive::AgentProfiles.lookup(:codex)
+            profile.bin
+          end
+        rescue StandardError
+          "codex"
+        end
+      end
+
+      def wrapper_path
+        # lib/hive/scripts/ — same path ClaudeLauncher#wrapper_command uses.
+        File.expand_path("../scripts/interactive_claude_wrapper.sh", __dir__)
+      end
+
+      def codex_auth_path
+        home = @env["CODEX_HOME"].to_s
+        home = File.join(@env.fetch("HOME", Dir.home), ".codex") if home.empty?
+        File.join(home, "auth.json")
+      end
+
+      def global_config_path
+        File.join(Hive::Paths.config_home, "config.yml")
+      end
+
+      def skill_inventory_hash
+        roots = [
+          File.join(@env.fetch("HOME", Dir.home), ".claude", "skills"),
+          File.join(@env.fetch("HOME", Dir.home), ".codex", "skills"),
+          File.join(Hive::Paths.data_home, "skills")
+        ]
+        entries = roots.flat_map do |root|
+          next [] unless File.directory?(root)
+
+          Dir.children(root).sort.map { |name| "#{root}/#{name}:#{file_mtime(File.join(root, name))}" }
+        rescue SystemCallError
+          []
+        end
+        Digest::SHA256.hexdigest(entries.join("|"))
+      end
+
+      def file_mtime(path)
+        return "" if path.nil? || path.empty?
+        return "" unless File.exist?(path)
+
+        File.mtime(path).to_f.to_s
+      rescue SystemCallError
+        ""
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/logger.rb b/lib/hive/daemon/logger.rb
index 6af59dc9..e7142da7 100644
--- a/lib/hive/daemon/logger.rb
+++ b/lib/hive/daemon/logger.rb
@@ -50,6 +50,9 @@ module Hive
         marker_heal_failed
         marker_heal_exhausted
         marker_heal_observer_missing
+        auto_retry_cleared
+        auto_retry_skipped
+        auto_retry_exhausted
         display_name_backfill
         update_available
         update_check_no_result
